﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        WebHierarchicalDataGrid1.DataSource = populateDataSet();
        WebHierarchicalDataGrid1.DataBind();
    }
    private DataSet populateDataSet()
    {

        DataSet ds = new DataSet();
        DataTable Parent = new DataTable();
        Parent.TableName = "Parent";
        DataTable Child = new DataTable();
        Child.TableName = "Child";

        Parent.Columns.Add("ID");
        Parent.Columns.Add("Name");

        DataColumn[] col = new DataColumn[1];
        col[0] = Parent.Columns["ID"];
        Parent.PrimaryKey = col;

        DataRow row = Parent.NewRow();
        row.SetField<int>("ID", 0);
        row.SetField<string>("Name", "Alice");
        Parent.Rows.Add(row);

        row = Parent.NewRow();
        row.SetField<int>("ID", 1);
        row.SetField<String>("Name", "Bob");
        Parent.Rows.Add(row);


        Child.Columns.Add("ID");
        Child.Columns.Add("Address");
        Child.Columns.Add("Count", typeof(int));

        row = Child.NewRow();
        row.SetField<int>("ID", 0);
        row.SetField<string>("Address", "Paris");
        row.SetField<int>("Count", 5);
        Child.Rows.Add(row);

        row = Child.NewRow();
        row.SetField<int>("ID", 1);
        row.SetField<string>("Address", "Rome");
        row.SetField<int>("Count", 9);
        Child.Rows.Add(row);

        row = Child.NewRow();
        row.SetField<int>("ID", 1);
        row.SetField<string>("Address", "London");
        row.SetField<int>("Count", 2);
        Child.Rows.Add(row);

        row = Child.NewRow();
        row.SetField<int>("ID", 0);
        row.SetField<string>("Address", "LosAngeles");
        row.SetField<int>("Count", 9);
        Child.Rows.Add(row);

        ds.Tables.Add(Parent);
        ds.Tables.Add(Child);

        for(int i=0;i<50; i++){
            row = Parent.NewRow();
            row.SetField<int>("ID", i + 5);
            row.SetField<string>("Name", "Name" + i);
            Parent.Rows.Add(row);
        }

        DataRelation relation = new DataRelation("IDRelation", Parent.Columns["ID"], Child.Columns["ID"]);
        ds.Relations.Add(relation);


        // Add the column in the parent DataTable which Sums the values from the children based on the id relation
        Parent.Columns.Add("Sum", typeof(int), "Sum(Child(IDRelation).Count)");

        return ds;
    }
    protected void WebHierarchicalDataGrid1_InitializeBand(object sender, Infragistics.Web.UI.GridControls.BandEventArgs e)
    {
        WebHierarchicalDataGrid band = e.Band as WebHierarchicalDataGrid;
        if (band == null)
        {
            return;
        }
        if (band.Behaviors.SummaryRow.ColumnSummaries.Count == 0)
        {

            // Add Total if a summary currently doesn't exist for a column

            for (int i = 0; i < band.Columns.Count; i++)
            {

                // add total footer to first visible column

                if (!band.Columns[i].Hidden)
                {

                    ColumnSummaryInfo csit = new ColumnSummaryInfo();

                    csit.ColumnKey = band.Columns[i].Key;

                    Summary s = new Summary();

                    s.SummaryType = SummaryType.Custom;

                    s.CustomSummaryName = "Totals";

                    csit.Summaries.Add(s);

                    band.Behaviors.SummaryRow.ColumnSummaries.Add(csit);

                    break;

                }

            }

        }

        band.Behaviors.SummaryRow.Enabled = true;

        band.Behaviors.SummaryRow.EnableInheritance = true;

        band.Behaviors.SummaryRow.ShowSummariesButtons = false;

        band.Behaviors.SummaryRow.FormatString = "{1}";

        band.Behaviors.SummaryRow.EmptyFooterText = " ";

        //TODO band.Behaviors.SummaryRow.SummariesCssClass = "";



        this.WebHierarchicalDataGrid1.RefreshBehaviors();

    }
    protected object WebHierarchicalDataGrid1_CalculateCustomSummary(object sender, CustomSummaryEventArgs e)
    {
        return "test";
    }
}